<template>
  <div class="background">
    <navbar></navbar>
    <div class="container">
      <div v-if="loaded">
        <h1 class="pt-3">Here is your quote in detail</h1>
        <b-row>
          <b-col class="col-lg-12 col-md-12 col-sm-12 col-12 d-flex align-items-stretch">
            <div>
              <b-card>
                <blockquote class="blockquote mb-0">
                  <p v-html="'&quot' + quote.en + '&quot'"></p>
                  <footer>
                    <span
                      class="blockquote-footer"
                      v-text="quote.author"
                    ></span>
                  </footer>
                </blockquote>
                <template v-slot:footer>
                  <div>
                    <font-awesome-icon
                      class="icons"
                      :icon="['fas', 'star']"
                    />
                    <small v-text="quote.rating"></small>
                  </div>
                </template>
              </b-card>
              <h3 class="pt-5 px-3">Do you like {{quote.author}}? We got you some more of his quotes!</h3>
              <div
                v-if="relevantloaded === false"
                class="text-center text-danger my-2 "
              >
                <b-spinner class="align-middle"></b-spinner>
                <strong>Loading...</strong>
              </div>
            </div>
          </b-col>
        </b-row>
      </div>
      <div class="test">
        <Quotes
          v-if="relevantloaded"
          :quotes="this.relevantQuotes"
        ></Quotes>
      </div>
    </div>
    <Footer></Footer>
  </div>
</template>
<script>
import Restclient from '../services/Restclient'
import Navbar from '@/components/Navbar.vue'
import Quotes from '@/components/Quotes.vue'
import Footer from '@/components/Footer.vue'

export default {
  name: 'detail',
  components: {
    Navbar,
    Quotes,
    Footer
  },
  props: ['id'],
  data () {
    return {
      restclient: new Restclient(),
      quoteId: 0,
      quote: null,
      loaded: false,
      relevantloaded: false,
      relevantQuotes: []
    }
  }, created: async function () {
    this.quoteId = this.$route.params.id
    this.quote = await this.restclient.getById(this.quoteId)
    this.loaded = true

    if (this.quote != null) {
      let allQuotes = await this.restclient.getAllQuotes()
      allQuotes.forEach((element) => {
        if (element.author === this.quote.author) {
          this.relevantQuotes.push(element)
        }
      })
      this.relevantQuotes.splice(3, this.relevantQuotes.length)
      this.relevantloaded = true
    }
  }, watch: {
    '$route': async function () {
      this.quoteId = this.$route.params.id
      this.quote = await this.restclient.getById(this.quoteId)
    }
  },
}
</script>
<style scoped>
.background {
  min-height: 900px;
  background-color: #f2f2f2;
}
@media screen and (max-width: 991px) {
  h1 {
    font-size: 25px;
  }
  h3 {
    font-size: 20px;
  }
  p {
    font-size: 15px;
  }
}
</style>